﻿namespace ShowTextBlockBug
{
    using System;
    using System.Diagnostics;
    using System.Windows;
    using System.Windows.Input;
    using System.Windows.Controls;
    using System.Windows.Documents;

    public partial class ShowTextBlockBugWindow : Window
    {
        public ShowTextBlockBugWindow()
        {
            // Initialize component
            InitializeComponent();
        }

        private void OnMouseDown(object sender, MouseButtonEventArgs e)
        {
            // Obtain the TextBlock
            TextBlock textBlock = (TextBlock)sender;

            // Determine where the user clicked inside the textblock
            Point pt = Mouse.GetPosition(textBlock);

            // Use workaround
            if (this.workaroundCheckbox.IsChecked.Value)
            {
                var dummy = textBlock.ContentStart;
            }

            // Obtain the start pointer
            TextPointer startPointer = textBlock.GetPositionFromPoint(pt, true);

            // Show the index
            MessageBox.Show(string.Format("Index: {0}", startPointer), "Notification", MessageBoxButton.OK, MessageBoxImage.Information);
        }

        private void OnNavigateToWebLog(object sender, RoutedEventArgs e)
        {
            Process.Start("http://blog.ramondeklein.nl?p=238");
        }
    }
}